'Version: 1.2
'Processes race and runner text files and reports results
'20080921 removed page breaks from reports
'20081005 changed results to outer join with time data and changed report header for oldest age group
'20090110 added report for unmatched time data
'20090831 added support for parameters (runner data file and race data file)


On Error Resume Next

retval = msgbox("Would you like to process a race results file?", vbYesNo, "Process Race Results?")
If retval = "6" Then
	'Global variables and objects
	Set objShell = WScript.CreateObject("WScript.Shell")
	Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")
	Set objSysEnv = objShell.Environment("SYSTEM")
	set objProcessEnv = objShell.Environment("PROCESS")
	Set objArgs = WScript.Arguments
	For I = 0 to objArgs.Count - 1
		'msgbox objArgs(I)
		If Left(objArgs(I), 11) = "RunnerData=" Then
			strRunnerDataFile = Replace(objArgs(I), Chr(1), " ")
			strRunnerDataFile = Replace(strRunnerDataFile, "RunnerData=", "")
		End If
		If Left(objArgs(I), 9) = "RaceData=" Then
			strRaceDataFile = Replace(objArgs(I), Chr(1), " ")
			strRaceDataFile = Replace(strRaceDataFile, "RaceData=", "")
		End If
	Next
'TEST
'wscript.quit

	strDBLoc = ""
	strRaceName = inputBox("Enter the Race Name", "Race Name")

	'create target directory
	strCurrentPath = Left(WScript.ScriptFullName, InStrRev(WScript.ScriptFullName, "\"))
	strTargetDir = strCurrentPath & strRaceName & "_" & DatePart("m", date) & "_" & DatePart("d", date) & "_" & DatePart("yyyy", date)
	If objFSO.FolderExists(strTargetDir) Then
		'do nothing
	Else
		objFSO.CreateFolder(strTargetDir)
		If Err.Number <> 0 Then
			msgbox "Error creating target directory: " & strTargetDir & vbCrLf & " Error: " & err.description
			WScript.Quit
		End If	
	End If

	'remove old discards file, if any
	strDiscardsFile = strTargetDir & "\Discards.txt"
	If objFSO.FileExists(strDiscardsFile) Then
		objFSO.CopyFile strDiscardsFile, strDiscardsFile & "_old", True
	End If
	Set objDiscards = objFSO.CreateTextFile(strDiscardsFile, True)

	'create database file
	CreateDB()

	'load raw race results file
	LoadRaceFile()

	'scrub raw data
	ScrubRaceData()
	
	'load runner file
	LoadRunnerFile()

	'create reports
	RunReports()

	objDiscards.Close	

End If



'***************************************************************************
'---------------------------------------------------------------------------
'creates database, tables & indexes
'---------------------------------------------------------------------------
Function CreateDB()

On Error Resume Next

'create new db file
strDBLoc = strTargetDir & "\" & strRaceName & ".mdb"

If objFSO.FileExists(strDBLoc) Then
	objFSO.CopyFile strDBLoc, strDBLoc & "_old", True
	objFSO.DeleteFile strDBLoc
End If

Set CatNewDB = CreateObject("ADOX.Catalog")
Set NewDB = CatNewDB.Create("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & strDBLoc)
If err.number <> 0 Then
	msgbox "Error creating database: " & err.description
	WScript.Quit
End If


Set Conn = CreateObject("ADODB.Connection")
strConn = "Driver={Microsoft Access Driver (*.mdb)};DBQ=" & strDBLoc & ";"
Conn.Open strConn
If err.number <> 0 Then
	msgbox "Error connecting to database: " & err.description
	WScript.Quit
Else
	Dim strDML(3)
	strDML(0) = "CREATE TABLE tblRawData (xTime VARCHAR, PlaceInLane VARCHAR NOT NULL, BibNo SINGLE)"
	strDML(1) = "CREATE TABLE tblResults (xTime VARCHAR NOT NULL, BibNo SINGLE NOT NULL CONSTRAINT PK_Constraint PRIMARY KEY)"
	strDML(2) = "CREATE TABLE tblRunnerData (FullName VARCHAR, Age INTEGER, Sex VARCHAR, BibNo SINGLE NOT NULL CONSTRAINT PK_Constraint1 PRIMARY KEY, City VARCHAR, State VARCHAR, Distance VARCHAR NOT NULL)"
	'strDML(3) = "CREATE VIEW vwOverallResults AS Select a.fullname as Name, b.xTime as [Time], a.Age, a.Sex, a.BibNo as [Bib #], a.City, a.State, a.Distance from tblRunnerData a, tblResults b Where a.BibNo = b.BibNo order by b.xTime"
	strDML(3) = "CREATE VIEW vwOverallResults AS Select a.fullname as Name, b.xTime as [Time], a.Age, a.Sex, a.BibNo as [Bib #], a.City, a.State, a.Distance from tblRunnerData a Left Outer JOIN tblResults b On a.BibNo = b.BibNo order by b.xTime"

	For x = 0 to UBound(strDML)
		Set ObjCommand = CreateObject("ADODB.Command")
		objCommand.ActiveConnection = Conn
		objCommand.CommandText = strDML(x)
		objCommand.Execute
		If err.number <> 0 Then
			msgbox "Error executing " & strDML(x) & vbcrlf & "Error: " & err.description
			WScript.Quit
		End If
	Next

End If

'msgbox "All DB scripts successfully executed."
Conn.Close
Set Conn = Nothing
End Function



'***************************************************************************
'---------------------------------------------------------------------------
'loads race results into tblRawData
'SAMPLE FILE FORMAT
' 1 010 0019 00:09:40.47
'11 010 0020 00:09:45.00   00021
'---------------------------------------------------------------------------
Function LoadRaceFile()

On Error Resume Next
	objDiscards.WriteLine("RACE DATA DISCARDS BELOW THIS LINE")
	strValidPath = "F"
	Do Until strValidPath = "T"
		If strRaceDataFile <> "" Then
			strPath = strRaceDataFile
		Else
			strPath = inputbox("Enter the full path to the RACE DATA file (from the timing machine):", "Locate RACE DATA File", strCurrentPath)
		End If

		If strPath = "" Then
			'quit
			Wscript.Quit
		Else
			If objFSO.FileExists(strPath) Then
				Set objFileSource = objFSO.OpenTextFile(strPath, 1, False)
				If Err.Number <> 0 Then
					msgbox "Error opening RACE DATA file: " & Err.Description
					WScript.Quit
				Else
					strValidPath = "T"
				End If

				'read each line and load into database
				intLineNo = 1

				Set Conn = CreateObject("ADODB.Connection")
				strConn = "Driver={Microsoft Access Driver (*.mdb)};DBQ=" & strDBLoc & ";"
				Conn.Open strConn
				If err.number <> 0 Then
					msgbox "Error opening database. Error: " & err.description
					WScript.Quit
				End If

				Set RS = CreateObject("ADODB.RecordSet")
				RS.Open "tblRawData", Conn, 1, 3
				If err.number <> 0 Then
					msgbox "Error opening tblRawData. Error: " & err.description
					WScript.Quit
				End If

				Do Until objFileSource.AtEndOfStream = True
					strResultLine = objFileSource.ReadLine()
					If Len(strResultLine) < 24 Then
						objDiscards.WriteLine(strResultLine)
					Else
						strRealData = Trim(strResultLine)
						strRealData = Trim(Mid(strRealData, 2, 32))
						strRealData = Replace(strRealData, "   ", " ")

						arrData = Split(strRealData, " ")
						If UBound(arrData) < 3 Then
							'this is junk
							objDiscards.WriteLine(strResultLine)
						Else
							Select Case UBound(arrData)
								Case "4"
									'line has bibno
									RS.AddNew
									RS.Fields(1).value = arrData(1)
									RS.Fields(2).value = arrData(4)
									RS.Update
									'msgbox "bibno " & arrData(1) & " " & arrData(4)
								Case "3"
									'line has time
									RS.AddNew
									RS.Fields(0).value = arrData(3)
									RS.Fields(1).value = arrData(1)
									RS.Update
									'msgbox "time " & arrData(3) & " " & arrData(1)
								Case Else
									objDiscards.WriteLine(strResultLine)
							End Select


							If Err.Number <> 0 Then
								msgbox "Error adding data to tblRawData. Error: " & err.description
								objDiscards.WriteLine(strResultLine & " Error: " & Err.Description)
								RS.CancelUpdate
								Err.Clear
								'WScript.Quit
							End If

							'msgbox "Results line #" & intLineNo & ": " & strRealData
						End If	
					End If
					intLineNo = intLineNo + 1
				Loop

				RS.Close
				Conn.Close

				msgbox intLineNo & " raw race records added"
			Else
				msgbox "File not found. Invalid path or filename."
				strValidPath = "F"
			End If
		End If
	Loop

End Function



'***************************************************************************
'---------------------------------------------------------------------------
'loads data from tblRawData into tblResults
'---------------------------------------------------------------------------
Function ScrubRaceData()

On Error Resume Next
Set Conn = CreateObject("ADODB.Connection")
strConn = "Driver={Microsoft Access Driver (*.mdb)};DBQ=" & strDBLoc & ";"
Conn.Open strConn
If err.number <> 0 Then
	msgbox "Error opening database. Error: " & err.description
	WScript.Quit
End If

Set ObjCommand = CreateObject("ADODB.Command")
objCommand.ActiveConnection = Conn
objCommand.CommandText = "Insert Into tblResults (xTime, BibNo) select a.Xtime, b.BibNo from tblRawData a, tblRawData b Where a.PlaceInLane = b.PlaceInLane and a.xTime is not null and b.BibNo is not null"
objCommand.Execute
If err.number <> 0 Then
	Select Case Err.Number
		Case "-2147217900"  'duplicate bib #s in the race data file
			Err.Clear
			strDuplicatesFile = strTargetDir & "\DuplicateBibNo.txt"
			Set objDuplicates = objFSO.CreateTextFile(strDuplicatesFile, True)
			Set RS = CreateObject("ADODB.RecordSet")
			strSql = "Select BibNo from tblRawData Where BibNo is not Null group by BibNo having count(*) > 1"
			RS.Open strSql, Conn, 0, 1
			If err.number <> 0 Then
				msgbox "Error processing race data file. Error: " & err.description
				WScript.Quit
			Else
				Do Until RS.EOF
					objDuplicates.WriteLine(RS.Fields(0).value)
					RS.MoveNext
				Loop
				objDuplicates.Close
				RS.Close
				Conn.Close
				msgbox "Duplicate bib number(s) found in the race data file.  Check the file DuplicateBibNo.txt, remove the duplicates from the race data file and rerun this program."
				WScript.Quit
			End If

		Case Else
			msgbox "Error loading results. Error: " & err.number & " " & err.description
			WScript.Quit
	End Select
End If
Conn.Close
End Function


'***************************************************************************
'---------------------------------------------------------------------------
'loads runner data into tblRunnerData
'SAMPLE FILE FORMAT
'Smith, John;41;M;1;City;ST;Distance
'---------------------------------------------------------------------------
Function LoadRunnerFile()

On Error Resume Next
	objDiscards.WriteLine(vbCrLf)
	objDiscards.WriteLine("RUNNER DISCARDS BELOW THIS LINE")
	strValidPath = "F"
	Do Until strValidPath = "T"
		If strRunnerDataFile <> "" Then
			strPath = strRunnerDataFile
		Else
			strPath = inputbox("Enter the full path to the RUNNER Demographic DATA file:", "Locate RUNNER DATA File", strCurrentPath)
		End If

		If strPath = "" Then
			'quit
			Wscript.Quit
		Else
			If objFSO.FileExists(strPath) Then
				Set objFileSource = objFSO.OpenTextFile(strPath, 1, False)
				If Err.Number <> 0 Then
					msgbox "Error opening RUNNER DATA file: " & Err.Description
					WScript.Quit
				Else
					strValidPath = "T"
				End If

				'read each line and load into database
				intLineNo = 1

				Set Conn = CreateObject("ADODB.Connection")
				strConn = "Driver={Microsoft Access Driver (*.mdb)};DBQ=" & strDBLoc & ";"
				Conn.Open strConn
				If err.number <> 0 Then
					msgbox "Error opening database. Error: " & err.description
					WScript.Quit
				End If

				Set RS = CreateObject("ADODB.RecordSet")
				RS.Open "tblRunnerData", Conn, 1, 3
				If err.number <> 0 Then
					msgbox "Error opening tblRunnerData. Error: " & err.description
					WScript.Quit
				End If

				Do Until objFileSource.AtEndOfStream = True
					strResultLine = objFileSource.ReadLine()
					If Len(strResultLine) < 5 Then
						objDiscards.WriteLine(strResultLine)
					Else
						strRealData = Trim(strResultLine)
						arrData = Split(strRealData, ";")
						Select Case UBound(arrData)
							Case "6"
								'line has time
								RS.AddNew
								If Len(arrData(0)) > 0 Then
									RS.Fields(0).value = arrData(0)
								End If

								If Len(arrData(1)) > 0 Then
									RS.Fields(1).value = arrData(1)
								End If

								If Len(arrData(2)) > 0 Then
									RS.Fields(2).value = arrData(2)
								End If

								RS.Fields(3).value = arrData(3)
								'msgbox "bib no " & arrData(3)

								If Len(arrData(4)) > 0 Then
									RS.Fields(4).value = arrData(4)
								End If

								If Len(arrData(5)) > 0 Then
									RS.Fields(5).value = arrData(5)
								End If

								If Len(arrData(6)) > 0 Then
									RS.Fields(6).value = arrData(6)
								End If

								RS.Update

								If Err.Number <> 0 Then
									msgbox "Error adding data to tblRunnerData. Error: " & err.description
									objDiscards.WriteLine(strResultLine & " Error: " & Err.Description)
									RS.CancelUpdate
									Err.Clear
									'WScript.Quit
								End If

							Case Else
								objDiscards.WriteLine(strResultLine & " Error: insufficient delimeters")

						End Select
					End If
					intLineNo = intLineNo + 1
				Loop
				
				RS.Close
				Conn.Close

				msgbox intLineNo & " Runner records processed"
			Else
				msgbox "File not found. Invalid path or filename."
				strValidPath = "F"
			End If
		End If
	Loop

End Function


'***************************************************************************
'---------------------------------------------------------------------------
'Displays Reports Menu
'---------------------------------------------------------------------------
Function RunReports()
On Error Resume Next

Set Conn = CreateObject("ADODB.Connection")
'Conn.Mode = 16
strConn = "Driver={Microsoft Access Driver (*.mdb)};DBQ=" & strDBLoc & ";"
Conn.Open strConn
If err.number <> 0 Then
	msgbox "Error opening database. Error: " & err.description
	WScript.Quit
End If

'get race distances
Set RSDistances = CreateObject("ADODB.RecordSet")
RSDistances.Open "Select Distinct Distance from tblRunnerData", Conn, 0, 1
If err.number <> 0 Then
	msgbox "Error opening runner table. Error: " & err.description
	WScript.Quit
End If
Do Until RSDistances.EOF
	strDistances = strDistances & RSDistances.Fields(0).value & ";"
	RSDistances.MoveNext
Loop
RSDistances.Close
Set RSDistances = Nothing
strDistances = Left(strDistances, Len(strDistances) - 1)
arrDistances = Split(strDistances, ";")

Do Until retVal = "5"
retVal = inputBox("Enter a report number:" & vbCrLf & vbCrLf & "1. Overall Results" & vbCrLf & "2. Overall Results: Female/Male" & vbCrLf & "3. Age Groups: Female/Male" & vbCrLf & "4. CRITICAL ERRORS: Unmatched Time File Data" & vbCrLf & "5. Exit", "Report Menu")
	Select Case retVal
		Case "1"
		For dist = 0 to UBound(arrDistances)
			strLine = ""
			'OVERALL
			strReportHeader = "<h1 align=center>" & strRaceName & " " & FormatDateTime(Date, 2) & "<br />" & arrDistances(dist) & " Overall Results</h1>"
			Set RS = CreateObject("ADODB.RecordSet")
			'strSql = "Select * from vwOverallResults where Distance ='" & arrDistances(dist) & "'"
			strSql = "Select Name, [Time], Age, Sex, [Bib #], City, State, Distance from vwOverallResults where Distance = '" & arrDistances(dist) & "' and [Time] is not null"
			strSql = strSql & " UNION ALL "
			strSql = strSql & "Select Name, 'No Time Data For Bib#' as [Time], Age, Sex, [Bib #], City, State, Distance from vwOverallResults where Distance = '" & arrDistances(dist) & "' and [Time] is null order by [Time]"

			RS.Open strSql, Conn, 0, 1
			If err.number <> 0 Then
				msgbox "Error creating report. Error: " & err.description & vbcrlf & strSql
				WScript.Quit
			Else
				'create report text file
				strReportFile = strTargetDir & "\" & arrDistances(dist) & "OverallResults.htm"
				If objFSO.FileExists(strReportFile) Then
					objFSO.DeleteFile strReportFile
				End If
				Set objReport = objFSO.CreateTextFile(strReportFile, True)
				objReport.WriteLine("<html><head><title>" & strRaceName & "</title></head>" & strReportHeader & "<div class=page><table align=center border=1 cellpadding=0 cellspacing=0>")
				
				With RS
					For x = 0 to .Fields.Count - 1
						strLine = strLine & "<th>" & .Fields(x).Name & "</th>"
					Next
					objReport.WriteLine("<th>Place</th>" & strLine)

					rec_num = 1
					Do Until .EOF
						strLine = ""
						For x = 0 to .Fields.Count - 1
							strLine = strLine & "<td>" & .Fields(x).value & "</td>"
						Next

						If .Fields("Time").value = "No Time Data For Bib#" Then
							strLine = "<tr><td></td>" & strLine & "</tr>"
						Else
							strLine = "<tr><td>" & rec_num & "</td>" & strLine & "</tr>"
						End If

						objReport.WriteLine(strLine)
						.MoveNext
						rec_num = rec_num + 1
					Loop
				End With
				objReport.WriteLine("</table></div>")
				objReport.WriteLine("</html>")
				objReport.Close
			End If

			RS.Close
			Set RS = Nothing

			Set objIE = WScript.Createobject("InternetExplorer.Application")
			objIE.Visible = True
			objIE.Navigate(strReportFile)
		Next

		Case "2"
		For dist = 0 to UBound(arrDistances)		
			'OVERALL MALE/FEMALE
			strReportHeader = "<h1 align=center>" & strRaceName & " " & FormatDateTime(Date, 2) & "<br />" & arrDistances(dist) & " Overall Results (Female)</h1>"
			Set RS = CreateObject("ADODB.RecordSet")
			Set RS1 = CreateObject("ADODB.RecordSet")
			strSql = "Select Name, [Time], Age, Sex, [Bib #], City, State, Distance from vwOverallResults where Sex = 'F' And Distance ='" & arrDistances(dist) & "' and [Time] is not null"
			strSql = strSql & " Union All "
			strSql = strSql & "Select Name, 'No Time Data For Bib#' as [Time], Age, Sex, [Bib #], City, State, Distance from vwOverallResults where Sex = 'F' And Distance ='" & arrDistances(dist) & "' and [Time] is null order by [Time]"

			strSql1 = "Select Name, [Time], Age, Sex, [Bib #], City, State, Distance from vwOverallResults where Sex = 'M' And Distance ='" & arrDistances(dist) & "' and [Time] is not null"
			strSql1 = strSql1 & " Union All "
			strSql1 = strSql1 & "Select Name, 'No Time Data For Bib#' as [Time], Age, Sex, [Bib #], City, State, Distance from vwOverallResults where Sex = 'M' And Distance ='" & arrDistances(dist) & "' and [Time] is null order by [Time]"

			RS.Open strSql, Conn, 0, 1
			RS1.Open strSql1, Conn, 0, 1

			If err.number <> 0 Then
				msgbox "Error creating report. Error: " & err.description & vbcrlf & strSql
				WScript.Quit
			Else
				'create report text file
				strReportFile = strTargetDir & "\" & arrDistances(dist) & "OverallResultsFemaleMale.htm"
				If objFSO.FileExists(strReportFile) Then
					objFSO.DeleteFile strReportFile
				End If
				Set objReport = objFSO.CreateTextFile(strReportFile, True)

				'FEMALE
				objReport.WriteLine("<html><head><title>" & strRaceName & "</title></head>" & strReportHeader & "<div class=page><table align=center border=1 cellpadding=0 cellspacing=0>")
				
				With RS
					strLine = ""
					For x = 0 to .Fields.Count - 1
						strLine = strLine & "<th>" & .Fields(x).Name & "</th>"
					Next
					objReport.WriteLine("<th>Place</th>" & strLine)

					rec_num = 1
					Do Until .EOF
						strLine = ""
						For x = 0 to .Fields.Count - 1
							strLine = strLine & "<td>" & .Fields(x).value & "</td>"
						Next

						'strLine = "<tr><td>" & rec_num & "</td>" & strLine & "</tr>"
						If .Fields("Time").value = "No Time Data For Bib#" Then
							strLine = "<tr><td></td>" & strLine & "</tr>"
						Else
							strLine = "<tr><td>" & rec_num & "</td>" & strLine & "</tr>"
						End If

						objReport.WriteLine(strLine)
						.MoveNext
						rec_num = rec_num + 1
					Loop
				End With
				objReport.WriteLine("</table></div><br />")


				'MALE
				strReportHeader = "<h1 align=center>" & strRaceName & " " & FormatDateTime(Date, 2) & "<br />" & arrDistances(dist) & " Overall Results (Male)</h1>"
				objReport.WriteLine(strReportHeader & "<div class=page><table align=center border=1 cellpadding=0 cellspacing=0>")
				
				With RS1
					strLine = ""
					For x = 0 to .Fields.Count - 1
						strLine = strLine & "<th>" & .Fields(x).Name & "</th>"
					Next
					objReport.WriteLine("<th>Place</th>" & strLine)

					rec_num = 1
					Do Until .EOF
						strLine = ""
						For x = 0 to .Fields.Count - 1
							strLine = strLine & "<td>" & .Fields(x).value & "</td>"
						Next

						'strLine = "<tr><td>" & rec_num & "</td>" & strLine & "</tr>"
						If .Fields("Time").value = "No Time Data For Bib#" Then
							strLine = "<tr><td></td>" & strLine & "</tr>"
						Else
							strLine = "<tr><td>" & rec_num & "</td>" & strLine & "</tr>"
						End If


						objReport.WriteLine(strLine)
						.MoveNext
						rec_num = rec_num + 1
					Loop
				End With
				objReport.WriteLine("</table></div>")
				objReport.WriteLine("</html>")
				objReport.Close
			End If

			RS.Close
			RS1.Close
			Set RS = Nothing
			Set RS1 = Nothing

			Set objIE = WScript.Createobject("InternetExplorer.Application")
			objIE.Visible = True
			objIE.Navigate(strReportFile)
		Next

		Case "3"
		
			'AGE GROUPS MALE/FEMALE

			'get age groups
			bolValidGroups = "F"
			Do Until bolValidGroups = "T"
				strAgeGroups = InputBox("Enter age groups separated by a semicolon.", "Enter Age Groups", "1-9;10-14;15-19;20-29;30-39;40-49;50-59;60-69;70-100")
				If strAgeGroups = "" Then
					WScript.Quit
				End If
				arrAllGroups = Split(strAgeGroups, ";")
				If UBound(arrAllGroups) <= 0 Then
					msgbox "Invalid entry.  Please try again."
					bolValidGroups = "F"
				Else
					For g = 0 to UBound(arrAllGroups)
						'test age brackets
						arrBracket = Split(arrAllGroups(g), "-")
						If UBound(arrBracket) <> 1 Then
							msgbox "Invalid age group" & arrAllGroups(g) & ".  Please try again."
							bolValidGroups = "F"
							Exit For
						Else
							If Not IsNumeric(arrBracket(0)) Or Not IsNumeric(arrBracket(1)) Then
								msgbox "Invalid age group" & arrAllGroups(g) & ".  Please try again."
								bolValidGroups = "F"
								Exit For
							Else
								If CInt(arrBracket(0)) > CInt(arrBracket(1)) Then
									msgbox "Invalid age group" & arrAllGroups(g) & ".  Please try again."
									bolValidGroups = "F"
									Exit For
								Else
									If g = UBound(arrAllGroups) Then
										bolValidGroups = "T"
									End If
								End If
							End If
						End If
					Next

				End If
			Loop
			'msgbox "data is valid"
			'WScript.Quit

		For dist = 0 to UBound(arrDistances)
			'create report text file
			strReportFile = strTargetDir & "\" & arrDistances(dist) & "AgeGroupsFemaleMale.htm"
			If objFSO.FileExists(strReportFile) Then
				objFSO.DeleteFile strReportFile
			End If
			Set objReport = objFSO.CreateTextFile(strReportFile, True)
			'objReport.WriteLine("<html><head><title>" & strRaceName & "</title><STYLE>div.page{page-break-after:always}</STYLE></head>")
			objReport.WriteLine("<html><head><title>" & strRaceName & "</title></head>")

			Set RS = CreateObject("ADODB.RecordSet")
			Set RS1 = CreateObject("ADODB.RecordSet")

			For f = 0 to UBound(arrAllGroups)
				arrBracket = Split(arrAllGroups(f), "-")
				strWhere = "And Age Between " & arrBracket(0) & " And " & arrBracket(1) & " And Distance ='" & arrDistances(dist) & "'"
				strSql = "Select Name, [Time], Age, Sex, [Bib #], City, State, Distance from vwOverallResults where Sex = 'F' " & strWhere & " and [Time] is not null"
				strSql = strSql & " Union All "
				strSql = strSql & "Select Name, 'No Time Data For Bib#' as [Time], Age, Sex, [Bib #], City, State, Distance from vwOverallResults where Sex = 'F' " & strWhere & " and [Time] is null order by [Time]"

				strSql1 = "Select Name, [Time], Age, Sex, [Bib #], City, State, Distance from vwOverallResults where Sex = 'M' " & strWhere & " and [Time] is not null"
				strSql1 = strSql1 & " Union All "
				strSql1 = strSql1 & "Select Name, 'No Time Data For Bib#' as [Time], Age, Sex, [Bib #], City, State, Distance from vwOverallResults where Sex = 'M' " & strWhere & " and [Time] is null order by [Time]"

				'msgbox strSql & vbcrlf & strsql1
				RS.Open strSql, Conn, 0, 1
				RS1.Open strSql1, Conn, 0, 1

				'FEMALE
				If f = UBound(arrAllGroups) Then
					strReportHeader = "<h1 align=center>" & strRaceName & " " & FormatDateTime(Date, 2) & "<br />" & arrDistances(dist) & " Females Age " & arrBracket(0) & " And Over</h1>"
				Else
					strReportHeader = "<h1 align=center>" & strRaceName & " " & FormatDateTime(Date, 2) & "<br />" & arrDistances(dist) & " Females Age " & arrBracket(0) & " - " & arrBracket(1) & "</h1>"
				End IF
				objReport.WriteLine(strReportHeader & "<div class=page><table align=center border=1 cellpadding=0 cellspacing=0>")
				With RS
					strLine = ""
					For x = 0 to .Fields.Count - 1
						strLine = strLine & "<th>" & .Fields(x).Name & "</th>"
					Next
					objReport.WriteLine("<th>Place</th>" & strLine)

					rec_num = 1
					Do Until .EOF
						strLine = ""
						For x = 0 to .Fields.Count - 1
							strLine = strLine & "<td>" & .Fields(x).value & "</td>"
						Next
						
						'strLine = "<tr><td>" & rec_num & "</td>" & strLine & "</tr>"
						If .Fields("Time").value = "No Time Data For Bib#" Then
							strLine = "<tr><td></td>" & strLine & "</tr>"
						Else
							strLine = "<tr><td>" & rec_num & "</td>" & strLine & "</tr>"
						End If

						objReport.WriteLine(strLine)
						.MoveNext
						rec_num = rec_num + 1
					Loop
				End With
				objReport.WriteLine("</table></div><br />")

				'MALE
				If f = UBound(arrAllGroups) Then
					strReportHeader = "<h1 align=center>" & strRaceName & " " & FormatDateTime(Date, 2) & "<br />" & arrDistances(dist) & " Males Age " & arrBracket(0) & " And Over</h1>"
				Else
					strReportHeader = "<h1 align=center>" & strRaceName & " " & FormatDateTime(Date, 2) & "<br />" & arrDistances(dist) & " Males Age " & arrBracket(0) & " - " & arrBracket(1) & "</h1>"
				End If
				objReport.WriteLine(strReportHeader & "<div class=page><table align=center border=1 cellpadding=0 cellspacing=0>")				
				With RS1
					strLine = ""
					For x = 0 to .Fields.Count - 1
						strLine = strLine & "<th>" & .Fields(x).Name & "</th>"
					Next
					objReport.WriteLine("<th>Place</th>" & strLine)

					rec_num = 1
					Do Until .EOF
						strLine = ""
						For x = 0 to .Fields.Count - 1
							strLine = strLine & "<td>" & .Fields(x).value & "</td>"
						Next

						'strLine = "<tr><td>" & rec_num & "</td>" & strLine & "</tr>"
						If .Fields("Time").value = "No Time Data For Bib#" Then
							strLine = "<tr><td></td>" & strLine & "</tr>"
						Else
							strLine = "<tr><td>" & rec_num & "</td>" & strLine & "</tr>"
						End If

						objReport.WriteLine(strLine)
						.MoveNext
						rec_num = rec_num + 1
					Loop
				End With
				objReport.WriteLine("</table></div>")

				RS.Close
				RS1.Close
			Next
	
			objReport.WriteLine("</html>")
			objReport.Close

			Set objIE = WScript.Createobject("InternetExplorer.Application")
			objIE.Visible = True
			objIE.Navigate(strReportFile)
		Next



		Case "4"
		For dist = 0 to UBound(arrDistances)
			strLine = ""
			'Unmatched Times
			strReportHeader = "<h1 align=center>" & strRaceName & " " & FormatDateTime(Date, 2) & " All Races " & "<br />" & " CRITICAL ERRORS: Unmatched Time File Data</h1>"
			Set RS = CreateObject("ADODB.RecordSet")
			strSql = "Select BibNo, xTime as [Time] from tblResults where BibNo Not In (Select BibNo From tblRunnerData) order by xTime"

			RS.Open strSql, Conn, 0, 1
			If err.number <> 0 Then
				msgbox "Error creating report. Error: " & err.description & vbcrlf & strSql
				WScript.Quit
			Else
				'create report text file
				strReportFile = strTargetDir & "\" & arrDistances(dist) & "UnmatchedTimes.htm"
				If objFSO.FileExists(strReportFile) Then
					objFSO.DeleteFile strReportFile
				End If
				Set objReport = objFSO.CreateTextFile(strReportFile, True)
				objReport.WriteLine("<html><head><title>" & strRaceName & "</title></head>" & strReportHeader & "<div class=page><table align=center border=1 cellpadding=0 cellspacing=0>")
				
				With RS
					For x = 0 to .Fields.Count - 1
						strLine = strLine & "<th>" & .Fields(x).Name & "</th>"
					Next
					objReport.WriteLine(strLine)
					
					Do Until .EOF
						strLine = ""
						For x = 0 to .Fields.Count - 1
							strLine = strLine & "<td>" & .Fields(x).value & "</td>"
						Next

						strLine = "<tr>" & strLine & "</tr>"

						objReport.WriteLine(strLine)
						.MoveNext
					Loop
				End With
				objReport.WriteLine("</table></div>")
				objReport.WriteLine("</html>")
				objReport.Close
			End If

			RS.Close
			Set RS = Nothing

			Set objIE = WScript.Createobject("InternetExplorer.Application")
			objIE.Visible = True
			objIE.Navigate(strReportFile)
		Next


		Case Else
			retVal = "5"
	End Select
Loop

Conn.Close

End Function